<?php

namespace App\Command;

use App\Service\NoteMoyenne;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class UpdateCommentairesCommand extends Command
{
    private $em;
    private $notesAndComs;

    public function __construct(EntityManagerInterface $em, NoteMoyenne $notesAndComs)
    {
        $this->em = $em;
        $this->notesAndComs = $notesAndComs;
        parent::__construct();
    }

    protected function configure()
    {
        $this
            ->setName('app:commentaires:update')
            ->setDescription('Update les notes et nb coms')
        ;
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $films = $this->em->getRepository('App:Film')->findAll();
        foreach ($films as $film)
        {
            $this->notesAndComs->calculerMoyenne($film);
        }

        $output->writeln('Tous les coms et toutes les notes sont mis à jour');
    }

}
