<?php

namespace App\Controller;

use App\Repository\FilmRepository;
use App\Service\OptionsManager;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;

class VideothequePersonnelleController extends AbstractController
{
	/**
     * @Route("/maliste/", name="videothequepersonnelle_maliste")
     */
	public function maListeAction (Request $request, FilmRepository $repo, OptionsManager $options)
    {
        $films = $repo->findTousFavoritesByUser($this->getUser());

        return $this->render('videotheque/liste_'.$options->vue().'.html.twig', array(
            'listeFilms'    =>  $films,
            'titre'         =>  'Ma liste de films à voir'
        ));
    }


	/*public function maListeAction (Request $request)
    {
        $resultats = array();
        $user = $this->getUser();
        foreach ($user->getFilms() as $key => $film) {
            $resultats[$key] = $this->get('serializer')->serialize($film, 'json');
        }
        return new JsonResponse($resultats);
    }*/

    /**
     * @Route("/maliste/modifieravoir/", name="maliste_modifier_a_voir")
     * @param Request $request
     * @return JsonResponse
     */
    public function modifierFilmDansListeAction(Request $request, EntityManagerInterface $em, FilmRepository $repo)
    {
        $film = $repo->find($request->request->get('id_film'));
        if ($request->isXmlHttpRequest())
        {
            $film->inverseUserWantToView($this->getUser());
            $em->flush();
        }
        /*$resultat = $this->get('serializer')->serialize($film, 'json');*/
        return new JsonResponse('OK');
    }

    /**
     * @Route("/maliste/modifiervus/", name="maliste_modifier_vus")
     * @param Request $request
     * @return JsonResponse
     */
    public function modifierFilmVusAction(Request $request, FilmRepository $repo, EntityManagerInterface $em)
    {
        $film = $repo->find($request->request->get('id_film'));
        if ($request->isXmlHttpRequest())
        {
            $film->inverseUserWhoSeen($this->getUser());
            $em->flush();
        }
        /*$resultat = $this->get('serializer')->serialize($film, 'json');*/
        return new JsonResponse('OK');
    }

}
