<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Realisateur
 *
 * @ORM\Table(name="realisateur")
 * @ORM\Entity(repositoryClass="App\Repository\RealisateurRepository")
 */
class Realisateur
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     * @ORM\Column(name="nom_complet", type="string", length=191, unique=true)
     */
    private $nomComplet;

    /**
     * @ORM\ManyToMany(targetEntity="App\Entity\Film", mappedBy="realisateurs", cascade={"persist"})
     * @var \Doctrine\Common\Collections\Collection
     */
    private $films;

    /**
     * Get id
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->films = new \Doctrine\Common\Collections\ArrayCollection();
    }

    /**
     * Add film
     *
     * @param \App\Entity\Film $film
     *
     * @return Realisateur
     */
    public function addFilm(\App\Entity\Film $film)
    {
        $this->films[] = $film;

        return $this;
    }

    /**
     * Remove film
     *
     * @param \App\Entity\Film $film
     */
    public function removeFilm(\App\Entity\Film $film)
    {
        $this->films->removeElement($film);
    }

    /**
     * Get films
     *
     * @return \Doctrine\Common\Collections\Collection
     */
    public function getFilms()
    {
        return $this->films;
    }

    /**
     * Get nomComplet
     *
     * @return string
     */
    public function getNomComplet ()
    {
        return $this->nomComplet;
    }

    /**
     * Set nomComplet
     *
     * @param string $nomComplet
     *
     * @return Realisateur
     */
    public function setNomComplet($nom)
    {
        $this->nomComplet = $nom;

        return $this;
    }

}
