<?php

namespace App\Service;

use App\Entity\Film;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\Security\Core\Security;

/**
 * Class FilmManager
 */
class FilmManager {
    private $em;
    private $uc;
    private $user;
    private $cm;

    public function __construct(EntityManagerInterface $em, UniciteCollections $uc, CommentaireManager $cm, Security $security)
    {
        $this->em = $em;
        $this->uc = $uc;
        $this->cm = $cm;
        $this->user = $security->getUser();
    }

    public function addFilm (Film $film)
    {
        $film->setAuthered($this->user);
        $film = $this->uc->assureUniciteCollections($film);
        $this->em->persist($film);
        $this->em->flush();
    }

    public function editFilm(Film $film)
    {
        $film = $this->uc->assureUniciteCollections($film);
        $this->em->flush();
    }

    public function delFilm(Film $film)
    {
        $commentaires = $film->getCommentaires();
        foreach($commentaires as $commentaire)
        {
            $this->cm->delCommentaire($commentaire);
        }
        $this->em->remove($film);

        $this->em->flush();
    }
}