<?php

namespace App\Service;

use Twig\Environment;

/**
 * Envoi de mails
 */
class Mail
{
    protected $mailer;
    protected $templating;
    protected $from;
    protected $reply;
    protected $name;
    /**
     * Mail Manager
     * @param $mailer
     * @param $templating
     * @param $from
     * @param $reply
     * @param $name
     */
    public function __construct(\Swift_Mailer $mailer, Environment $templating, $from, $reply, $name)
    {
        $this->mailer = $mailer;
        $this->templating = $templating;
        $this->from = $from;
        $this->reply = $reply;
        $this->name = $name;
    }

    protected function sendMessage($subject, $to, $body)
    {
        $mail = new \Swift_Message($subject);
        $mail
            ->setFrom($this->from, $this->name)
            ->setTo($to)
            ->setSubject($subject)
            ->setBody($body)
            ->setReplyTo($this->reply, $this->name)
            ->setContentType('text/plain');

        return $this->mailer->send($mail);
    }

    public function sendMailActivation(\App\Entity\User $user, $lien)
    {
        $subject = "Activation de votre compte";
        $template = 'security/mail_activate.html.twig';
        $to = $user->getMail();
        $body = $this->templating->render($template, array('user' => $user, 'lien'  => $lien));
        $this->sendMessage($subject, $to, $body);
    }

    public function sendMailTokenMp(\App\Entity\User $user, $lien)
    {
        $subject = "Mot de passe perdu";
        $template = 'security/mail_tokenmdp.html.twig';
        $to = $user->getMail();
        $body = $this->templating->render($template, array('user' => $user, 'lien'  => $lien));
        $this->sendMessage($subject, $to, $body);
    }
}