<?php

namespace App\Service;


use App\Entity\Film;
use App\Entity\User;
use Symfony\Component\Routing\Generator\UrlGeneratorInterface;

/**
 * Envoi notifs mattermost
 */
class Mattermost
{
    protected $url;
    protected $token;
    protected $channelId;
    protected $router;

    /**
     * Mattermost Manager
     */
    public function __construct($url, $token, $channelId, UrlGeneratorInterface $router)
    {
        $this->url = $url . "/api/v4/posts";
        $this->token = $token;
        $this->channelId = $channelId;
        $this->router = $router;
    }

    protected function SendNotif($message)
    {
        // crée une nouvelle ressource cURL
        $ch = curl_init();

        // fixe l'URL et les autres options appropriées
        $options = array(
            CURLOPT_URL => $this->url,
            CURLOPT_HTTPHEADER => array('Content-Type: application/json', 'Authorization: Bearer ' . $this->token),
            CURLOPT_POSTFIELDS  =>  '{"channel_id": "' . $this->channelId . '", "message": "' . $message . '"}'
        );

        curl_setopt_array($ch, $options);

        // attrape l'URL et la passe au navigateur
        curl_exec($ch);

        // ferme la ressource cURL et libère les ressources systèmes
        curl_close($ch);
    }

    public function sendNouveauFilm(Film $film)
    {
        $message =
            ":new: **"
            .$film->getAuthered()->getUsername()
            ."** vient d'ajouter **"
            ."[".$film->getTitre()."]("
            .$this->router->generate('videotheque_voirfilm', ['id' => $film->getId()], UrlGeneratorInterface::ABSOLUTE_URL)
            .")** dans la [vidéothèque](https://videotheque.fdlibre.eu).";
        $this->SendNotif($message);
    }

    public function sendNouveauCommentaire(User $user, Film $film)
    {
        $message =
            ":new: **"
            .$user->getUsername()
            ."** vient d'ajouter un commentaire sur le film **"
            ."[".$film->getTitre()."]("
            .$this->router->generate('videotheque_voirfilm', ['id' => $film->getId()], UrlGeneratorInterface::ABSOLUTE_URL)
            .")** dans la [vidéothèque](https://videotheque.fdlibre.eu).";

        $this->SendNotif($message);
    }


}